Subject: bug#25122: 24.5; function describe-variable hangs on large variables

From: Drew Adams <[email-masked]>
Date: Sat, 11 Mar 2017 15:55:50 -0800 (PST)

> >> I think the better way out is to do less work.  E.g. bound the total
> >> amount printed (and replace the rest with "..." that can be expanded on
> >> demand).
> 
> Yes, there's no method that will achieve "instant" speeds for
> load-history sized lists (well except for plain prin1, but that output
> is hardly readable).
> 
> > The problem will be here again when you hit RET on "..."
> 
> Perhaps we could run the printing in a thread and suspend it after
> printing X lines.  Then hitting RET on "..." would just print another X
> lines.

(Caveat: I'm not really following this thread.)

If you plan to do things like what I think you're suggesting,
which will make a user hit several keys (e.g. RET on ...
repeatedly) then please make that behavior _optional_.

Give users the _possibility_ to just print the whole thing,
without any other action (no prefix arg, no clicking ... etc.).

I generally don't mind waiting, for example, and I don't
want to have to hit ... and wait for a bit more - I want
the whole thing the first time.

And if/when you do show the value only partially, please
make that _obvious_ to users.  They should _immediately_
know that they are not seeing the full value.